//+------------------------------------------------------------------+
//|                  _( ).mq4 |
//|                                                               TO |
//|                                        http://www.tradexperts.ru |
//+------------------------------------------------------------------+
#property copyright "TO"
#property link      "http://www.tradexperts.ru"
#define pi 3.14159265358979323846
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Violet
#property indicator_color2 OrangeRed
#property indicator_color3 Magenta
#property indicator_color4 PaleGreen
#property indicator_color5 DodgerBlue
#property indicator_color6 SpringGreen
#property indicator_color7 White
#property indicator_color8 MediumVioletRed

extern int NUM_BARS=300;
extern int NUM_HARMONICS=12;
extern int SHIFT=1000;

double Harmonic_1[];
double Harmonic_2[];
double Harmonic_3[];
double Harmonic_4[];
double Harmonic_5[];
double Harmonic_6[];
double Harmonic_7[];
double Harmonic_8[];


int h;
int init()
  {

   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(0,Harmonic_1);
   SetIndexStyle(1,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(1,Harmonic_2);
   SetIndexStyle(2,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(2,Harmonic_3);
   SetIndexStyle(3,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(3,Harmonic_4);
   SetIndexStyle(4,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(4,Harmonic_5);
   SetIndexStyle(5,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(5,Harmonic_6);
   SetIndexStyle(6,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(6,Harmonic_7);
   SetIndexStyle(7,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(7,Harmonic_8);

   return(0);
  }

int deinit()
  {

   return(0);
  }


int start()
{
   string comm="";
   for(int count=SHIFT;count>=0;count--)
   {
      double array[2];
      double array_cos[2];
      double array_sin[2];
      double amplitude_cos[2];
      double amplitude_sin[2];
      double buffer[2];
      double num_b=NUM_BARS;
      double OX=(2*pi)/num_b;
      double sum=0;
      ArrayResize(array,NUM_BARS);ArrayResize(array_cos,NUM_BARS);ArrayResize(array_sin,NUM_BARS);
      ArrayResize(amplitude_cos,NUM_HARMONICS);ArrayResize(amplitude_sin,NUM_HARMONICS);ArrayResize(buffer,NUM_BARS);
      ArrayInitialize(array,0.0);ArrayInitialize(array_cos,0.0);ArrayInitialize(array_sin,0.0);
      ArrayInitialize(amplitude_cos,0.0);ArrayInitialize(amplitude_sin,0.0);ArrayInitialize(buffer,0.0);
      for(int i=NUM_BARS-1;i>=0;i--)
         array[i]=Close[i+count];
   
      double aver=fAver(array);
   
      for(i=NUM_BARS-1;i>=0;i--)
         array[i]=array[i]-aver;
   
      for(int i1=1;i1<=NUM_HARMONICS;i1++)
      {
         for(i=NUM_BARS-1;i>=0;i--)
         {
            array_cos[i]=array[i]*MathCos(i1*OX*i);
            array_sin[i]=array[i]*MathSin(i1*OX*i);
         }
         amplitude_cos[i1-1]=2*fAver(array_cos);
         amplitude_sin[i1-1]=2*fAver(array_sin);
         
      }
      Harmonic_1[count]=0.0;Harmonic_2[count]=0.0;Harmonic_3[count]=0.0;Harmonic_4[count]=0.0;Harmonic_5[count]=0.0;Harmonic_6[count]=0.0;Harmonic_7[count]=0.0;Harmonic_8[count]=0.0;
      Harmonic_1[count]=amplitude_cos[0];
      Harmonic_2[count]=amplitude_sin[0];
      Harmonic_3[count]=amplitude_cos[1];
      Harmonic_4[count]=amplitude_sin[1];
      Harmonic_5[count]=amplitude_cos[2];
      Harmonic_6[count]=amplitude_sin[2];
      Harmonic_7[count]=amplitude_cos[3];
      Harmonic_8[count]=amplitude_sin[3];
      
   }
   
   return(0);
}

double fAver(double array[])//
{
   double i=ArrayRange(array,0)-1;
   double Aver=0;
   for(int count=0;count<i;count++)
      {Aver+=array[count];}

   Aver/=i;
   return(Aver);
}